module.exports = {
	extends: [
		"plugin:@typescript-eslint/recommended-type-checked",
		"plugin:@typescript-eslint/stylistic-type-checked",
	],

	rules: {
		/* prefer T[] for simple types, Array<T> for complex types (unions, etc) */
		"@typescript-eslint/array-type": ["error", { default: "array-simple" }],

		/* no-explicit-any is enabled and for now this rule is a bit to tedious to
		 * actually help */
		"@typescript-eslint/no-unsafe-member-access": "off",

		"@typescript-eslint/no-inferrable-types": "off",

		/* prefer interface over type = { .. } */
		"@typescript-eslint/consistent-type-definitions": ["error", "interface"],

		/* enforce usage of "type" with export/import */
		"@typescript-eslint/consistent-type-exports": [
			"error",
			{ fixMixedExportsWithInlineTypeSpecifier: true },
		],
		"@typescript-eslint/consistent-type-imports": "error",

		"@typescript-eslint/no-unused-vars": [
			"error",
			{
				ignoreRestSiblings: true,
				argsIgnorePattern: "^_",
			},
		],
	},
};
